VERSION 5.00
Begin VB.Form Kalender 
   Caption         =   "Form1"
   ClientHeight    =   3030
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   ScaleHeight     =   3030
   ScaleWidth      =   4560
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text5 
      Height          =   375
      Left            =   240
      TabIndex        =   5
      Text            =   "Text1"
      Top             =   2040
      Width           =   3615
   End
   Begin VB.TextBox Text4 
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Text            =   "Text1"
      Top             =   1560
      Width           =   3615
   End
   Begin VB.TextBox Text3 
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Text            =   "Text1"
      Top             =   1080
      Width           =   3615
   End
   Begin VB.TextBox Text2 
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Text            =   "Text1"
      Top             =   600
      Width           =   3615
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   240
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   120
      Width           =   3615
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   255
      Left            =   3480
      TabIndex        =   0
      Top             =   2760
      Width           =   855
   End
End
Attribute VB_Name = "Kalender"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'MoonAge (Date)

Sub MoonAge(strDate)
Dim tmp, arrtmp, strmonth, strday, stryear, strsep
Dim yy, y, m, d, p2, mm, k1, k2, k3, l, j, v, ip, ag, dp, di, la
Dim lo, po, rp, np, phase, thisphase
Dim Heledus

tmp = InStr(1, strDate, "/")
If tmp <> 0 Then
 strsep = "/"
Else
 tmp = InStr(1, strDate, "-")
 strsep = "-"
End If

arrtmp = Split(strDate, strsep, 3)
strmonth = arrtmp(0)
strday = arrtmp(1)
stryear = arrtmp(2)

y = stryear
m = strmonth
d = strday
p2 = 2 * 3.14159

yy = y - Int((12 - m) / 10)
mm = m + 9
If mm >= 12 Then
 mm = mm - 12
End If
k1 = Int(365.25 * (yy + 4712))
k2 = Int(30.6 * mm + 0.5)
k3 = Int(Int((yy / 100) + 49) * 0.75) - 38

' JD for dates in Julian calendar
j = k1 + k2 + d + 59
If j > 2299160 Then
' For Gregorian calendar
 j = j - k3
End If

' J is the Julian date at 12h UT on day in question

' Calculate illumination (synodic) phase
v = (j - 2451550.1) / 29.530588853
v = v - Int(v)
If v < 0 Then
 v = v + 1
End If
ip = v

' Moon's age in days
ag = ip * 29.53

' Convert phase to radians
ip = ip * p2

' Calculate distance from anomalistic phase
v = (j - 2451562.2) / 27.55454988
v = v - Int(v)
If v < 0 Then
 v = v + 1
End If
dp = v
dp = dp * p2: ' Convert to radians
di = 60.4 - 3.3 * Cos(dp) - 0.6 * Cos(2 * ip - dp) - 0.5 * Cos(2 * ip)

' Calculate latitude from nodal (draconic) phase
v = (j - 2451565.2) / 27.212220817
v = v - Int(v)
If v < 0 Then
 v = v + 1
End If
np = v

' Convert to radians
np = np * p2
la = 5.1 * Sin(np)

' Calculate longitude from sidereal motion
v = (j - 2451555.8) / 27.321582241
' Normalize values to range 0 to 1
v = v - Int(v)
If v < 0 Then
 v = v + 1
End If

rp = v
lo = 360 * rp + 6.3 * Sin(dp) + 1.3 * Sin(2 * ip - dp) + 0.7 * Sin(2 * ip)

' phases from
'http://home.hiwaay.net/~krcool/Astro/moon/moonphase/
phase = Array("new", "waxing crescent", "in its first quarter", _
"waxing gibbous", "full", "waning gibbous", _
"in its last quarter", "waning crescent")
Select Case Int(ag)
 Case 0, 29
  thisphase = 0
 Case 1, 2, 3, 4, 5, 6
  thisphase = 1
 Case 7
  thisphase = 2
 Case 8, 9, 10, 11, 12, 13
  thisphase = 3
 Case 14
  thisphase = 4
 Case 15, 16, 17, 18, 19, 20, 21
  thisphase = 5
 Case 22
  thisphase = 6
 Case 23, 24, 25, 26, 27, 28
  thisphase = 7
End Select

If (Int(ag) = 14) Then
    Heledus = 1
ElseIf (Int(ag) < 14) Then
    Heledus = 14 - Int(ag)
Else
    Heledus = Int(ag) - 14
End If
    
Text1.Text = "Moon's age (days): " & Int(ag)
Text2.Text = "Moon's phase: " & phase(thisphase) & ", " & "Heledus: " & Str(Heledus)
Text3.Text = "Distance (Earth radii): " & FormatNumber(di, 2)
Text4.Text = "Ecliptic latitude (degrees): " & FormatNumber(la, 2)
Text5.Text = "Ecliptic longitude (degrees): " & FormatNumber(lo, 2)

End Sub

Private Sub Command1_Click()
MoonAge (Date$)
End Sub

